{**********************************************************}
{      - }
{ .                                                     }
{    1.0  MarinovSoft                }
{            http://marinovsoft.narod.ru                   }
{            super386@rambler.ru                           }
{    GPL (.  copying)    }
{   ,   ..         }
{   ,      .         }
{     -      .   }
{**********************************************************}
unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, ExtCtrls, Math;

type
  TMainForm = class(TForm)
    Panel1: TPanel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    ComboBox4: TComboBox;
    ComboBox5: TComboBox;
    StaticText1: TStaticText;
    Image1: TImage;
    Panel2: TPanel;
    SpinEdit1: TSpinEdit;
    StaticText2: TStaticText;
    Panel3: TPanel;
    StaticText3: TStaticText;
    Label1: TLabel;
    procedure ComboBox1Change(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm     : TMainForm;

implementation

{$R *.dfm}

Const
  clCreame     = 14743024;

procedure TMainForm.ComboBox1Change(Sender: TObject);
var N1, N2, N3 : Byte;                                      { ,      }
  j            : extended;
  OmStr        : String;
  Dopusk       : String;
Const
  clBraun      = 13430;
  clOrange     = 25855;
  clGold       = 651500;
  Colors123    : Array[0..9] of Integer = (clBlack, clBraun, clRed, clOrange, clYellow, clGreen, clBlue, clFuchsia, clGray, clWhite);
  Colors4      : Array[0..11] of Integer = (clSilver, clGold, clBlack, clBraun, clRed, clOrange, clYellow, clGreen, clBlue, clFuchsia, clGray, clWhite);
  Colors5      : Array[0..7] of Integer = (clSilver, clGold, clBraun, clRed, clGreen, clBlue, clFuchsia, clGray);
begin
  N1 := ComboBox1.ItemIndex;
  N2 := ComboBox2.ItemIndex;
  If ComboBox3.Visible then N3 := ComboBox3.ItemIndex else N3 := 0;
  j := 100 * N1 + 10 * N2 + N3;
  j := j * Power(10, ComboBox4.ItemIndex - 2);
  OmStr := '';
  if j >= 1000000000 then
  begin
    j := j / 1000000000;
    OmStr := '';
  end;
  if j >= 1000000 then
  begin
    j := j / 1000000;
    OmStr := '';
  end;
  if j >= 1000 then
  begin
    j := j / 1000;
    OmStr := '';
  end;
  Dopusk := '20%';
  if ComboBox5.Visible then Case ComboBox5.ItemIndex of
      0: Dopusk := '10%';
      1: Dopusk := '5%';
      2: Dopusk := '1%';
      3: Dopusk := '2%';
      4: Dopusk := '0,5%';
      5: Dopusk := '0,25%';
      6: Dopusk := '0,1%';
      7: Dopusk := '0,05%';
    end;
  Label1.Caption := FloatToStr(j) + ' ' + OmStr + ' ' + Dopusk;
With Image1.Canvas do
begin
  Brush.Color := clCreame;
  Rectangle(80, 54, 220, 162);
  Brush.Color := Colors123[ComboBox1.ItemIndex];
  FillRect(Rect(85, 54, 95, 162));
  Brush.Color := Colors123[ComboBox2.ItemIndex];
  FillRect(Rect(105, 54, 115, 162));
  case SpinEdit1.Value of
    3: begin
        Brush.Color := Colors4[ComboBox4.ItemIndex];
        FillRect(Rect(125, 54, 135, 162));
      end;
    4: begin
        Brush.Color := Colors4[ComboBox4.ItemIndex];
        FillRect(Rect(125, 54, 135, 162));
        Brush.Color := Colors5[ComboBox5.ItemIndex];
        FillRect(Rect(145, 54, 155, 162));
      end;
    5: begin
        Brush.Color := Colors123[ComboBox3.ItemIndex];
        FillRect(Rect(125, 54, 135, 162));
        Brush.Color := Colors4[ComboBox4.ItemIndex];
        FillRect(Rect(145, 54, 155, 162));
        Brush.Color := Colors5[ComboBox5.ItemIndex];
        FillRect(Rect(165, 54, 175, 162));
      end;
  end;
end;
end;

procedure TMainForm.SpinEdit1Change(Sender: TObject);
begin
  if SpinEdit1.Value < 5 then ComboBox3.Visible := False;
  if SpinEdit1.Value < 4 then ComboBox5.Visible := False;
  if SpinEdit1.Value > 3 then ComboBox5.Visible := True;
  if SpinEdit1.Value > 4 then ComboBox3.Visible := True;
  ComboBox1Change(Sender);
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
With Image1.Canvas do
begin
  Brush.Color := clCreame;
  Rectangle(40, 46, 80, 170);
  Rectangle(260, 46, 220, 170);
  Rectangle(80, 54, 220, 162);
  Rectangle(10, 100, 40, 116);
  Rectangle(260, 100, 290, 116);
end;
  ComboBox1Change(Sender);
end;

end.

